# MoveTask

Extends \CopyTask

Moves a file or directory to a new file or directory.

By default, the destination file is overwritten if it already exists. When overwrite is turned off, then files are only moved if the source file is newer than the destination file, or when the destination file does not exist.

Source files and directories are only deleted when the file or directory has been copied to the destination successfully.

package | phing.tasks.system

### Methods

## Sets up this object internal stuff.

    __construct()

inherited

i.e. the Fileutils instance and default mode.

## Compares source files to destination files to see if they should be copied.

    _scan( &$fromDir,  &$toDir,  &$files,  &$dirs) : void

inherited

### Arguments

#### $fromDir

``

#### $toDir

``

#### $files

``

#### $dirs

``

## Nested creator, creates a FileSet for this task

    addFileSet(\FileSet $fs) : void

inherited

### Arguments

#### $fs

`\FileSet`

Set of files to copy

## Builds a map of filenames (from->to) that should be copied

    buildMap( &$fromDir,  &$toDir,  &$names,  &$mapper,  &$map) : void

inherited

### Arguments

#### $fromDir

``

#### $toDir

``

#### $names

``

#### $mapper

``

#### $map

``

## copyToSingleDestination

    copyToSingleDestination( $from,  $to,  $fromSlot,  $fromBasenameSlot,  $toSlot,  $toBasenameSlot,  &$count,  &$total)

inherited

### Arguments

#### $from

``

#### $to

``

#### $fromSlot

``

#### $fromBasenameSlot

``

#### $toSlot

``

#### $toBasenameSlot

``

#### $count

``

#### $total

``

## Nested creator, adds a set of files (nested fileset attribute).

    createFileList() : \FileList

inherited

### Response

`\FileList`

The created filelist object

## Creates a filterchain

    createFilterChain() : \FilterChain

inherited

### Response

`\FilterChain`

The created filterchain object

## Nested creator, creates one Mapper for this task

    createMapper() : \Mapper

inherited

throws |

### Response

`\Mapper`

The created Mapper type object

## Go and delete the directory tree.

    deleteDir( $d)

throws |

### Arguments

#### $d

``

## Actually copies the files

    doWork() : void

inherited

throws |

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## getMapper

    getMapper()

inherited

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## isEnabledMultipleMappings

    isEnabledMultipleMappings()

inherited

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## logError

    logError(string $message, null $location = null)

inherited

throws |

### Arguments

#### $message

`string`

#### $location

`null`

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Its only ok to delete a dir tree if there are no files in it.

    okToDelete( $d) : boolean

throws |

### Arguments

#### $d

``

### Response

`boolean`

## Perfrom this task

    perform()

inherited

throws |

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## setEnableMultipleMappings

    setEnableMultipleMappings( $enableMultipleMappings)

inherited

### Arguments

#### $enableMultipleMappings

``

## Set the file. We have to manually take care of the type that is coming due to limited type support in php in and convert it manually if necessary.

    setFile(\PhingFile $file) : void

inherited

### Arguments

#### $file

`\PhingFile`

The source file. Either a string or an PhingFile object

## Set the haltonerror attribute - when true, will make the build fail when errors are detected.

    setHaltonerror(boolean $haltonerror) : void

inherited

### Arguments

#### $haltonerror

`boolean`

Flag if the build should be stopped on errors

## Set the include empty dirs flag. IntrospectionHelper takes care of booleans in set* methods so we can assume that the right value (boolean primitive) is coming in here.

    setIncludeEmptyDirs(boolean $bool) : void

inherited

### Arguments

#### $bool

`boolean`

Flag if empty dirs should be cpoied too

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the mode to create destination directories with (ignored on Windows).

    setMode(integer $mode) : void

inherited

Default mode is taken from umask()

### Arguments

#### $mode

`integer`

Octal mode

## Set the overwrite flag. IntrospectionHelper takes care of booleans in set* methods so we can assume that the right value (boolean primitive) is coming in here.

    setOverwrite(boolean $bool) : void

inherited

### Arguments

#### $bool

`boolean`

Overwrite the destination file(s) if it/they already exist

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Set the preserve timestamp flag. IntrospectionHelper takes care of booleans in set* methods so we can assume that the right value (boolean primitive) is coming in here.

    setPreserveLastModified( $bool) : void

inherited

### Arguments

#### $bool

``

## setPreservemode

    setPreservemode( $bool)

inherited

### Arguments

#### $bool

``

## Set the preserve permissions flag. IntrospectionHelper takes care of booleans in set* methods so we can assume that the right value (boolean primitive) is coming in here.

    setPreservepermissions(boolean $bool) : void

inherited

### Arguments

#### $bool

`boolean`

Preserve the timestamp on the destination file

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Set the toDir. We have to manually take care of the type that is coming due to limited type support in php in and convert it manually if necessary.

    setTodir(\PhingFile $dir) : void

inherited

### Arguments

#### $dir

`\PhingFile`

The directory, either a string or an PhingFile object

## Set the toFile. We have to manually take care of the type that is coming due to limited type support in php in and convert it manually if necessary.

    setTofile(\PhingFile $file) : void

inherited

### Arguments

#### $file

`\PhingFile`

The dest file. Either a string or an PhingFile object

## setTstamp

    setTstamp( $bool)

inherited

see | \CopyTask::setPreserveLastModified

### Arguments

#### $bool

``

## Used to force listing of all names of copied files.

    setVerbose(boolean $verbosity)

inherited

### Arguments

#### $verbosity

`boolean`

## Validates attributes coming in from XML

    validateAttributes() : void

inherited

throws |

### Properties

## file

    file :

inherited

### Type(s)

``

## destFile

    destFile :

inherited

### Type(s)

``

## destDir

    destDir :

inherited

### Type(s)

``

## overwrite

    overwrite :

inherited

### Type(s)

``

## preserveLMT

    preserveLMT :

inherited

### Type(s)

``

## preservePermissions

    preservePermissions :

inherited

### Type(s)

``

## includeEmpty

    includeEmpty :

inherited

### Type(s)

``

## flatten

    flatten :

inherited

### Type(s)

``

## mapperElement

    mapperElement :

inherited

### Type(s)

``

## fileCopyMap

    fileCopyMap :

inherited

### Type(s)

``

## dirCopyMap

    dirCopyMap :

inherited

### Type(s)

``

## completeDirMap

    completeDirMap :

inherited

### Type(s)

``

## fileUtils

    fileUtils :

inherited

### Type(s)

``

## filesets

    filesets :

inherited

### Type(s)

``

## filelists

    filelists :

inherited

### Type(s)

``

## filterChains

    filterChains :

inherited

### Type(s)

``

## verbosity

    verbosity :

inherited

### Type(s)

``

## mode

    mode : integer

inherited

var |

### Type(s)

`integer`

## haltonerror

    haltonerror : boolean

inherited

var |

### Type(s)

`boolean`

## enableMultipleMappings

    enableMultipleMappings :

inherited

### Type(s)

``

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`